// Generated by LiveScript 1.5.0
(function(){
  var path, ref$, log, logPad, logHalfPad, getConfig, writeConfig, deepClone, underline, plus, minus, mergeGhoti, whatIsCurrent, checkAvailability, calculateNewUpdate, calculateNewMinus, calculateNewUnderlinePlus, calculateNewUnderlineSet, calculateProgress, out$ = typeof exports != 'undefined' && exports || this;
  path = require('path');
  ref$ = require('../log/std'), log = ref$.log, logPad = ref$.logPad, logHalfPad = ref$.logHalfPad;
  ref$ = require('../func/config'), getConfig = ref$.getConfig, writeConfig = ref$.writeConfig;
  deepClone = require('../func/deepclone').deepClone;
  underline = function(ghoti){
    return ghoti;
  };
  plus = function(name){
    return name;
  };
  minus = function(name){
    return name;
  };
  mergeGhoti = function(ghoti, pathE, re){
    var path, newGhoti, subPath, endPath, i$, len$, i, j$, ref$, len1$, j, to$;
    path = deepClone(pathE);
    newGhoti = deepClone(ghoti);
    subPath = newGhoti.underline.path;
    endPath = path.pop();
    if (!Boolean(endPath)) {
      newGhoti.underline.path = re;
      return newGhoti;
    }
    for (i$ = 0, len$ = path.length; i$ < len$; ++i$) {
      i = path[i$];
      if (subPath.child) {
        for (j$ = 0, len1$ = (ref$ = subPath.child).length; j$ < len1$; ++j$) {
          j = ref$[j$];
          if (deepEq$(j.name, i, '===')) {
            subPath = j;
            break;
          }
        }
      } else {
        for (j$ = 0, len1$ = subPath.length; j$ < len1$; ++j$) {
          j = subPath[j$];
          if (deepEq$(j.name, i, '===')) {
            subPath = j;
            break;
          }
        }
      }
    }
    if (subPath.child) {
      for (i$ = 0, to$ = subPath.child.length - 1; i$ <= to$; ++i$) {
        i = i$;
        if (deepEq$(subPath.child[i].name, endPath, '===')) {
          subPath.child[i] = re;
        }
      }
    } else {
      for (i$ = 0, to$ = subPath.length - 1; i$ <= to$; ++i$) {
        i = i$;
        if (deepEq$(subPath[i].name, endPath, '===')) {
          subPath[i] = re;
        }
      }
    }
    return newGhoti;
  };
  whatIsCurrent = function(current){
    switch (current.type) {
    case 'set':
      return 'Ghoti underline SET';
    case 'task':
      return 'Ghoti underline Task';
    default:
      return 'Ghoti underline Root or not a underline path';
    }
  };
  checkAvailability = function(current, context){
    var i$, ref$, len$, i;
    switch (current.type) {
    case 'set':
      if (deepEq$(context, '', '===')) {
        return false;
      }
      for (i$ = 0, len$ = (ref$ = current.child).length; i$ < len$; ++i$) {
        i = ref$[i$];
        if (deepEq$(i.name, context, '===')) {
          return false;
        }
      }
      return true;
    case 'task':
      return true;
    default:
      if (deepEq$(context, '', '===')) {
        return false;
      }
      for (i$ = 0, len$ = current.length; i$ < len$; ++i$) {
        i = current[i$];
        if (deepEq$(i.name, context, '===')) {
          return false;
        }
      }
      return true;
    }
    return true;
  };
  calculateNewUpdate = function(currentE, progress, comment, whenDone){
    var current;
    current = deepClone(currentE);
    if (!deepEq$(current.type, 'task', '===')) {
      logPad('| You are trying to update a "' + whatIsCurrent(current) + '"', 1);
      logPad('| Progress update must be created in a "task" not a "set", or a "root"', 1);
      logPad('| You can use "ghoti _[somepath(task)]! [prog] [...Comments]" to update a "task"', 1);
      whenDone();
      process.exit();
    } else {
      if (deepEq$(parseInt(progress), NaN, '===')) {
        logPad('| You can use "ghoti _[somepath(task)]! [prog] [...Comments]" to update a "task"', 1);
        whenDone();
        process.exit();
      }
      current.tea.push({
        type: 'prog',
        from: current.prog,
        to: parseInt(progress),
        comment: comment
      });
      current.prog = parseInt(progress);
    }
    return current;
  };
  calculateNewMinus = function(currentE, comment, whenDone){
    var current;
    current = deepClone(currentE);
    if (!deepEq$(current.type, 'task', '===')) {
      logPad('| You are trying to complete a "' + whatIsCurrent(current) + '"', 1);
      logPad('| Task complete must be created in a "task" not a "set", or a "root"', 1);
      logPad('| You can use "ghoti _[somepath(task)]- [...Comments]" to complete a "task"', 1);
      whenDone();
      process.exit();
    } else {
      current.tea.push({
        type: 'complete',
        from: current.prog,
        to: 100,
        comment: comment
      });
      current.prog = 100;
    }
    return current;
  };
  calculateNewUnderlinePlus = function(currentE, name, whenDone){
    var current;
    current = deepClone(currentE);
    if (deepEq$(current.type, 'task', '===')) {
      logPad('| You are trying to create task in a "' + whatIsCurrent(current) + '"', 1);
      logPad('| New task must be created in a "set" or "root" not a "task"', 1);
      logPad('| You can use "ghoti _[somepath(set, root)]#" to create a "set"', 1);
      whenDone();
      process.exit();
    } else {
      if (current.child) {
        current.child.push({
          name: name,
          type: 'task',
          tea: [],
          prog: 0
        });
      } else if (current.push) {
        current.push({
          name: name,
          type: 'task',
          tea: [],
          prog: 0
        });
      } else {
        logPad('| Unknown error', 1);
        process.exit();
      }
    }
    return current;
  };
  calculateNewUnderlineSet = function(currentE, name, whenDone){
    var current;
    current = deepClone(currentE);
    if (deepEq$(current.type, 'task', '===')) {
      logPad('| You are trying to create set in a "' + whatIsCurrent(current) + '"', 1);
      logPad('| New set must be created in a "set" or "root" not a "task"', 1);
      logPad('| You can use "ghoti _[somepath(set, root)]#" to create a "set"', 1);
      whenDone();
      process.exit();
    } else {
      if (current.child) {
        current.child.push({
          name: name,
          type: 'set',
          tea: [],
          child: []
        });
      } else if (current.push) {
        current.push({
          name: name,
          type: 'set',
          tea: [],
          child: []
        });
      } else {
        logPad('| Unknown error', 1);
        process.exit();
      }
    }
    return current;
  };
  calculateProgress = function(current, whenDone, arg$, arg1$){
    var ref$, doLog, logLevel, total, amount, calculateProgressRecursion;
    if ((ref$ = arg$ != null ? arg$ : false) != null) {
      doLog = ref$;
    }
    if ((ref$ = arg1$ != null ? arg1$ : 1) != null) {
      logLevel = ref$;
    }
    total = 0;
    amount = 0;
    calculateProgressRecursion = function(Rcurrent, level){
      var i$, len$, i, ref$;
      if (!Boolean(Rcurrent.type)) {
        for (i$ = 0, len$ = Rcurrent.length; i$ < len$; ++i$) {
          i = Rcurrent[i$];
          calculateProgressRecursion(i, level);
        }
      } else {
        if (deepEq$(Rcurrent.type, 'task', '===')) {
          if (doLog) {
            if (level <= logLevel) {
              logHalfPad('* ' + Rcurrent.name + ' > Progress: ' + Rcurrent.prog + '%', level);
            }
          }
          amount += Rcurrent.prog;
          total += 1;
        } else {
          if (doLog) {
            if (level <= logLevel) {
              logHalfPad('- ' + Rcurrent.name + ' > Size: ' + Rcurrent.child.length, level);
            }
          }
          for (i$ = 0, len$ = (ref$ = Rcurrent.child).length; i$ < len$; ++i$) {
            i = ref$[i$];
            calculateProgressRecursion(i, level + 1);
          }
        }
      }
    };
    calculateProgressRecursion(current, 0);
    return {
      total: total,
      amount: amount
    };
  };
  out$.underline = underline;
  out$.plus = plus;
  out$.minus = minus;
  out$.mergeGhoti = mergeGhoti;
  out$.whatIsCurrent = whatIsCurrent;
  out$.checkAvailability = checkAvailability;
  out$.calculateProgress = calculateProgress;
  out$.calculateNewMinus = calculateNewMinus;
  out$.calculateNewUpdate = calculateNewUpdate;
  out$.calculateNewUnderlineSet = calculateNewUnderlineSet;
  out$.calculateNewUnderlinePlus = calculateNewUnderlinePlus;
  function deepEq$(x, y, type){
    var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
        has = function (obj, key) { return hasOwnProperty.call(obj, key); };
    var first = true;
    return eq(x, y, []);
    function eq(a, b, stack) {
      var className, length, size, result, alength, blength, r, key, ref, sizeB;
      if (a == null || b == null) { return a === b; }
      if (a.__placeholder__ || b.__placeholder__) { return true; }
      if (a === b) { return a !== 0 || 1 / a == 1 / b; }
      className = toString.call(a);
      if (toString.call(b) != className) { return false; }
      switch (className) {
        case '[object String]': return a == String(b);
        case '[object Number]':
          return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
        case '[object Date]':
        case '[object Boolean]':
          return +a == +b;
        case '[object RegExp]':
          return a.source == b.source &&
                 a.global == b.global &&
                 a.multiline == b.multiline &&
                 a.ignoreCase == b.ignoreCase;
      }
      if (typeof a != 'object' || typeof b != 'object') { return false; }
      length = stack.length;
      while (length--) { if (stack[length] == a) { return true; } }
      stack.push(a);
      size = 0;
      result = true;
      if (className == '[object Array]') {
        alength = a.length;
        blength = b.length;
        if (first) {
          switch (type) {
          case '===': result = alength === blength; break;
          case '<==': result = alength <= blength; break;
          case '<<=': result = alength < blength; break;
          }
          size = alength;
          first = false;
        } else {
          result = alength === blength;
          size = alength;
        }
        if (result) {
          while (size--) {
            if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
          }
        }
      } else {
        if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
          return false;
        }
        for (key in a) {
          if (has(a, key)) {
            size++;
            if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
          }
        }
        if (result) {
          sizeB = 0;
          for (key in b) {
            if (has(b, key)) { ++sizeB; }
          }
          if (first) {
            if (type === '<<=') {
              result = size < sizeB;
            } else if (type === '<==') {
              result = size <= sizeB
            } else {
              result = size === sizeB;
            }
          } else {
            first = false;
            result = size === sizeB;
          }
        }
      }
      stack.pop();
      return result;
    }
  }
}).call(this);
