// Generated by LiveScript 1.5.0
(function(){
  var fs, path, os, log, path_ghoti, readFileC, cliPath, tempConfig, getConfig, getGameConfig, writeConfig, writeGameConfig, writeCLIConfig, readCLIConfig, initConfig, updateConfig, out$ = typeof exports != 'undefined' && exports || this;
  fs = require('fs');
  path = require('path');
  os = require('os');
  log = require('../log/log').log;
  path_ghoti = require('../func/argv').path_ghoti;
  readFileC = require('./fs/fileController').readFileC;
  cliPath = function(){
    switch (os.platform()) {
    case 'win32':
      return path.join(path_ghoti, "..", "..");
    case 'darwin':
      return path.join(path_ghoti, "..", "..", "lib", "node_modules", "ghoti-cli");
    default:
      return path.join(path_ghoti, "..", "..", "lib", "node_modules", "ghoti-cli");
    }
  };
  tempConfig = function(type){
    var config;
    switch (type) {
    case 'react':
      config = {
        type: 'react'
      };
      break;
    case 'vue':
      config = {
        type: 'vue'
      };
      break;
    case 'electron-react':
      config = {
        type: 'electron-react'
      };
      break;
    default:
      log('ghoti init have to use format "ghoti init [type] [path]"');
      log('You can findout all type with "ghoti list"');
      process.exit();
    }
    return config;
  };
  getConfig = function(){
    var config, path_current, configExist;
    path_current = process.cwd();
    configExist = fs.existsSync(path.join(path_current, '.ghoticonfig'));
    if (configExist) {
      config = JSON.parse(readFileC(path.join(path_current, '.ghoticonfig'), 'utf8'));
    } else {
      config = null;
    }
    return config;
  };
  getGameConfig = function(){
    var config, path_current, configExist;
    path_current = process.cwd();
    configExist = fs.existsSync(path.join(path_current, '.ghotigameconfig'));
    if (configExist) {
      config = JSON.parse(readFileC(path.join(path_current, '.ghotigameconfig'), 'utf8'));
    } else {
      config = null;
    }
    return config;
  };
  writeConfig = function(config){
    var path_current, configExist;
    path_current = process.cwd();
    configExist = fs.existsSync(path.join(path_current, '.ghoticonfig'));
    if (configExist) {
      fs.writeFileSync(path.join(path_current, '.ghoticonfig'), JSON.stringify(config, null, 2), 'utf8');
      return configExist;
    } else {
      fs.writeFileSync(path.join(path_current, '.ghoticonfig'), JSON.stringify(config, null, 2), 'utf8');
      return true;
    }
  };
  writeGameConfig = function(config){
    var path_current, configExist;
    path_current = process.cwd();
    configExist = fs.existsSync(path.join(path_current, '.ghotigameconfig'));
    if (configExist) {
      fs.writeFileSync(path.join(path_current, '.ghotigameconfig'), JSON.stringify(config), 'utf8');
      return configExist;
    } else {
      fs.writeFileSync(path.join(path_current, '.ghotigameconfig'), JSON.stringify(config), 'utf8');
      return true;
    }
  };
  writeCLIConfig = function(config){
    var configExist;
    configExist = fs.existsSync(path.join(cliPath(), '.ghoticonfig'));
    if (configExist) {
      fs.writeFileSync(path.join(cliPath(), '.ghoticonfig'), JSON.stringify(config), 'utf8');
      return configExist;
    } else {
      fs.writeFileSync(path.join(cliPath(), '.ghoticonfig'), JSON.stringify(config), 'utf8');
      return true;
    }
  };
  readCLIConfig = function(){
    var configExist;
    configExist = fs.existsSync(path.join(cliPath(), '.ghoticonfig'));
    if (configExist) {
      return JSON.parse(readFileC(path.join(cliPath(), '.ghoticonfig'), 'utf8'));
    } else {
      return false;
    }
  };
  initConfig = function(type){
    writeConfig(tempConfig(type));
  };
  updateConfig = function(newConfig){
    writeConfig(newConfig);
  };
  out$.getConfig = getConfig;
  out$.cliPath = cliPath;
  out$.writeConfig = writeConfig;
  out$.initConfig = initConfig;
  out$.tempConfig = tempConfig;
  out$.updateConfig = updateConfig;
  out$.readCLIConfig = readCLIConfig;
  out$.writeCLIConfig = writeCLIConfig;
  out$.getGameConfig = getGameConfig;
  out$.writeGameConfig = writeGameConfig;
}).call(this);
