// Generated by LiveScript 1.5.0
(function(){
  var fs, path, log, libFile, ref$, commonParse, commonGather, executeExternalFile, readFileC, makeDir, switchRoot, readFile, writeFile, getFileRoot, fileFromAchieve, file, out$ = typeof exports != 'undefined' && exports || this;
  fs = require('fs');
  path = require('path');
  log = require('../log/std').log;
  libFile = require('../static/file').libFile;
  ref$ = require('./parser/parser'), commonParse = ref$.commonParse, commonGather = ref$.commonGather;
  executeExternalFile = require('../static/outer/achieve').executeExternalFile;
  readFileC = require('./fs/fileController').readFileC;
  makeDir = function(root){
    if (!fs.existsSync(root)) {
      return fs.mkdirSync(root);
    }
  };
  switchRoot = function(type, ghoti_root){
    var re;
    re = libFile(type, ghoti_root);
    if (re) {
      return re;
    } else {
      return null;
    }
  };
  readFile = function(root, vars){
    return commonParse(readFileC(root, 'utf8'), vars);
  };
  writeFile = function(root, data){
    if (deepEq$(root.substring(root.length - 6, root.length), '.ghoti', '===')) {
      return fs.writeFileSync(root.substring(0, root.length - 6), data, 'utf8');
    } else {
      return fs.writeFileSync(root, data, 'utf8');
    }
  };
  getFileRoot = function(location, filePath, fileName, ghoti_root){
    if (deepEq$(location, 'built-in', '===')) {
      return path.join(ghoti_root, 'lib', 'files', filePath, fileName);
    } else {
      return filePath;
    }
  };
  fileFromAchieve = function(ghoti_root, fileName, targetPath, whenDone, env){
    return executeExternalFile(ghoti_root, fileName, targetPath, whenDone, env, function(externalPath, ghotiinstall){
      var filePath;
      filePath = path.join(externalPath, ghotiinstall.main);
      return commonGather(ghotiinstall.replaces, function(vars){
        if (env.rename) {
          return commonGather(['rename'], function(rename){
            var targetName;
            targetName = rename[0].value;
            writeFile(path.join(targetPath, targetName), readFile(filePath, vars));
            log('| File copied');
            return whenDone();
          });
        } else {
          makeDir(targetPath);
          writeFile(path.join(targetPath, ghotiinstall.main), readFile(filePath, vars));
          log('| File copied');
          return whenDone();
        }
      });
    });
  };
  file = function(ghoti_root, fileName, targetPathE, whenDone, env){
    var targetPath, root;
    if (!Boolean(fileName)) {
      log('| File format: "ghoti file [type] [path?]", add -f for external file');
      log('| See all available file types: "ghoti lf"');
      log('| Try: "ghoti info file"');
      whenDone();
      process.exit();
    }
    if (!targetPathE) {
      targetPath = process.cwd();
    } else {
      targetPath = targetPathE;
    }
    if (env.fetch) {
      fileFromAchieve(ghoti_root, fileName, targetPath, whenDone, env);
    } else {
      root = switchRoot(fileName, ghoti_root);
      if (!Boolean(root)) {
        log(' | file "' + fileName + '" is not a valid file name');
        log(' | Try "ghoti files" or "ghoti lf" for the list of valid files');
        whenDone();
        process.exit();
      } else {
        commonGather(root.replaces, function(vars){
          if (env.rename) {
            return commonGather(['rename'], function(rename){
              var targetName;
              targetName = rename[0].value;
              writeFile(path.join(targetPath, targetName), readFile(getFileRoot(root.location, root.path, root.file, ghoti_root), vars));
              log('| File copied');
              return whenDone();
            });
          } else {
            makeDir(targetPath);
            writeFile(path.join(targetPath, root.file), readFile(getFileRoot(root.location, root.path, root.file, ghoti_root), vars));
            log('| File copied');
            return whenDone();
          }
        });
      }
    }
  };
  out$.file = file;
  function deepEq$(x, y, type){
    var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
        has = function (obj, key) { return hasOwnProperty.call(obj, key); };
    var first = true;
    return eq(x, y, []);
    function eq(a, b, stack) {
      var className, length, size, result, alength, blength, r, key, ref, sizeB;
      if (a == null || b == null) { return a === b; }
      if (a.__placeholder__ || b.__placeholder__) { return true; }
      if (a === b) { return a !== 0 || 1 / a == 1 / b; }
      className = toString.call(a);
      if (toString.call(b) != className) { return false; }
      switch (className) {
        case '[object String]': return a == String(b);
        case '[object Number]':
          return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
        case '[object Date]':
        case '[object Boolean]':
          return +a == +b;
        case '[object RegExp]':
          return a.source == b.source &&
                 a.global == b.global &&
                 a.multiline == b.multiline &&
                 a.ignoreCase == b.ignoreCase;
      }
      if (typeof a != 'object' || typeof b != 'object') { return false; }
      length = stack.length;
      while (length--) { if (stack[length] == a) { return true; } }
      stack.push(a);
      size = 0;
      result = true;
      if (className == '[object Array]') {
        alength = a.length;
        blength = b.length;
        if (first) {
          switch (type) {
          case '===': result = alength === blength; break;
          case '<==': result = alength <= blength; break;
          case '<<=': result = alength < blength; break;
          }
          size = alength;
          first = false;
        } else {
          result = alength === blength;
          size = alength;
        }
        if (result) {
          while (size--) {
            if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
          }
        }
      } else {
        if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
          return false;
        }
        for (key in a) {
          if (has(a, key)) {
            size++;
            if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
          }
        }
        if (result) {
          sizeB = 0;
          for (key in b) {
            if (has(b, key)) { ++sizeB; }
          }
          if (first) {
            if (type === '<<=') {
              result = size < sizeB;
            } else if (type === '<==') {
              result = size <= sizeB
            } else {
              result = size === sizeB;
            }
          } else {
            first = false;
            result = size === sizeB;
          }
        }
      }
      stack.pop();
      return result;
    }
  }
}).call(this);
