// Generated by LiveScript 1.5.0
(function(){
  var fs, path, ref$, log, logPostInstall, parseAll, parseFile, commonGather, lib, commonPath, libCommons, executeExternal, executeSwitch, readFileC, switchRoot, removeTail, copyToPathBinary, copyToPath, readFile, makeDir, logPath, copyInitRecursions, copyInit, downloadArchive, readSpecialReplaces, readParseAll, identifyIsJavaScript, initFromAchieve, init, slice$ = [].slice, out$ = typeof exports != 'undefined' && exports || this;
  fs = require('fs');
  path = require('path');
  ref$ = require('../log/log'), log = ref$.log, logPostInstall = ref$.logPostInstall;
  ref$ = require('./parser/parser'), parseAll = ref$.parseAll, parseFile = ref$.parseFile, commonGather = ref$.commonGather;
  ref$ = require('../static/lib'), lib = ref$.lib, commonPath = ref$.commonPath, libCommons = ref$.libCommons;
  ref$ = require('../static/outer/achieve'), executeExternal = ref$.executeExternal, executeSwitch = ref$.executeSwitch;
  readFileC = require('./fs/fileController').readFileC;
  switchRoot = function(type, ghoti_root){
    var re;
    re = lib(type, ghoti_root);
    if (re) {
      log('| "', type + '" is a ' + re.location + ' ghoti-cli template.');
      return re;
    } else {
      return null;
    }
  };
  removeTail = function(filename){
    if (deepEq$(filename.substring(filename.length - 6, filename.length), '.ghoti', '===') || deepEq$(filename.substring(filename.length - 6, filename.length), '.ghotb', '===')) {
      return filename.substring(0, filename.length - 6);
    } else {
      return filename;
    }
  };
  copyToPathBinary = function(targetPath, filePath, whenDone){
    var fileReadStream, fileWriteStream;
    fileReadStream = fs.createReadStream(filePath);
    fileWriteStream = fs.createWriteStream(removeTail(targetPath));
    fileReadStream.pipe(fileWriteStream);
    fileWriteStream.on('error', function(){
      fileWriteStream.end();
      log('| Error on binary file copy');
      log('| Try "ghoti fix binary file copy"');
      whenDone();
      return process.exit();
    });
    fileReadStream.on('error', function(){
      fileWriteStream.end();
      log('| Error on binary file copy');
      log('| Try "ghoti fix binary file copy"');
      whenDone();
      return process.exit();
    });
  };
  copyToPath = function(root, data, arg$){
    var filename;
    if (arg$ != null) {
      filename = arg$;
    }
    if (deepEq$(filename, '.ghotiinstall', '===')) {
      return;
    }
    if (deepEq$(root.substring(root.length - 6, root.length), '.ghoti', '===')) {
      return fs.writeFileSync(root.substring(0, root.length - 6), data, 'utf8');
    } else {
      return fs.writeFileSync(root, data, 'utf8');
    }
  };
  readFile = function(filename, root, vars, specVars){
    return parseFile(filename, readFileC(root, 'utf8'), vars, specVars);
  };
  makeDir = function(root){
    if (!fs.existsSync(root)) {
      return fs.mkdirSync(root);
    }
  };
  logPath = function(text, level){
    var space, i$;
    space = '';
    for (i$ = 0; i$ <= level; ++i$) {
      space += ' |';
    }
    return log(space + text);
  };
  copyInitRecursions = function(root, level, targetPath, beforeLength, vars, specVars, whenDone){
    var files, eachFile;
    files = fs.readdirSync(root);
    eachFile = function(file){
      var pathname, stat, floatRoot;
      pathname = path.join(root, file);
      stat = fs.lstatSync(pathname);
      floatRoot = root.substring(beforeLength, root.length);
      if (stat.isDirectory()) {
        logPath('- ' + removeTail(file), level);
        makeDir(path.join(targetPath, floatRoot, file));
        return copyInitRecursions(pathname, level + 1, targetPath, beforeLength, vars, specVars, whenDone);
      } else {
        if (deepEq$(file.substring(file.length - 6, file.length), '.ghotb', '===')) {
          logPath('# ' + removeTail(file), level);
          return copyToPathBinary(path.join(targetPath, floatRoot, file), pathname, whenDone);
        } else {
          logPath('* ' + removeTail(file), level);
          return copyToPath(path.join(targetPath, floatRoot, file), readFile(file, pathname, vars, specVars), file);
        }
      }
    };
    return files.forEach(eachFile);
  };
  copyInit = function(type, targetPath, vars, specVars, root, whenDone){
    var path_current;
    path_current = process.cwd();
    makeDir(path.join(path_current, targetPath));
    return copyInitRecursions(root, 0, path.join(path_current, targetPath), root.length, vars, specVars, whenDone);
  };
  downloadArchive = function(ghoti_root, type, targetPath, whenDone, env){
    executeSwitch(ghoti_root, type, targetPath, whenDone, env, function(externalPath, ghotiinstall){
      log('| Finished.');
      log('| see "ghoti lt" & "ghoti lf" for new available list');
      whenDone();
    });
  };
  readSpecialReplaces = function(root, callback){
    return commonGather(root.replaces, function(vars){
      return callback(vars);
    });
  };
  readParseAll = function(textList, targetPath, env, conff, callback){
    log('| @ Reading project information');
    return parseAll(textList, targetPath, env, function(re, typesciprt){
      if (conff.replaces) {
        log('| @ Reading special information');
        return readSpecialReplaces(conff, function(newRe){
          return callback(re, newRe, typesciprt);
        });
      } else {
        log('| @ No special information');
        return callback(re, [], typesciprt);
      }
    });
  };
  identifyIsJavaScript = function(language){
    if (deepEq$(language, 'TypeScript', '===') || deepEq$(language, 'JavaScript', '===')) {
      return true;
    } else {
      return false;
    }
  };
  initFromAchieve = function(ghoti_root, type, targetPath, whenDone, env){
    executeExternal(ghoti_root, type, targetPath, whenDone, env, function(externalPath, ghotiinstall){
      readParseAll(type, targetPath, env, ghotiinstall, function(re, newRe, typesciprt){
        var count, common, i$, len$, i;
        log(' | @ Copying lib files');
        copyInit(type, targetPath, re, newRe, externalPath);
        log(' | @ Copying common files');
        common = libCommons(ghotiinstall.common, ghoti_root);
        count = 0;
        if (re.open) {
          common.push(commonPath('common', 'open-source', ghoti_root));
          common.push(commonPath('common', 'license', ghoti_root));
        }
        for (i$ = 0, len$ = common.length; i$ < len$; ++i$) {
          i = common[i$];
          log(' | @ Common files chunk ' + count++);
          copyInit(type, targetPath, re, newRe, i);
        }
        whenDone();
      });
    });
  };
  init = function(ghoti_root, type, targetPath, whenDone, env){
    var root;
    if (!targetPath) {
      log('init have to use format "ghoti init [type] [path]"');
      log('type could be any typename in list "ghoti list" or "ghoti lt"');
      log('Try: "ghoti info init"');
      whenDone();
      process.exit();
    }
    if (env.fetch) {
      return initFromAchieve(ghoti_root, type, targetPath, whenDone, env);
    } else {
      root = switchRoot(type, ghoti_root);
      if (!Boolean(root)) {
        log(' | type "' + type + '" is not a valid type of ghoti type');
        log(' | Try "ghoti list" or "ghoti lt" for the list of valid types');
        whenDone();
        process.exit();
      }
      readParseAll(type, targetPath, env, root, function(re, newRe, typesciprt){
        var count, common, i$, len$, i;
        log(' | @ Copying lib files');
        copyInit(type, targetPath, re, newRe, root.path);
        log(' | @ Copying common files');
        common = slice$.call(root.common);
        count = 0;
        if (re.open) {
          if (identifyIsJavaScript(root.language)) {
            common.push(commonPath('common', 'open-source', ghoti_root));
          }
          common.push(commonPath('common', 'license', ghoti_root));
        }
        for (i$ = 0, len$ = common.length; i$ < len$; ++i$) {
          i = common[i$];
          log(' | @ Common files chunk ' + count++);
          copyInit(type, targetPath, re, newRe, i);
        }
        logPostInstall(targetPath, type, typesciprt);
        whenDone();
      });
    }
  };
  out$.init = init;
  out$.downloadArchive = downloadArchive;
  function deepEq$(x, y, type){
    var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
        has = function (obj, key) { return hasOwnProperty.call(obj, key); };
    var first = true;
    return eq(x, y, []);
    function eq(a, b, stack) {
      var className, length, size, result, alength, blength, r, key, ref, sizeB;
      if (a == null || b == null) { return a === b; }
      if (a.__placeholder__ || b.__placeholder__) { return true; }
      if (a === b) { return a !== 0 || 1 / a == 1 / b; }
      className = toString.call(a);
      if (toString.call(b) != className) { return false; }
      switch (className) {
        case '[object String]': return a == String(b);
        case '[object Number]':
          return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
        case '[object Date]':
        case '[object Boolean]':
          return +a == +b;
        case '[object RegExp]':
          return a.source == b.source &&
                 a.global == b.global &&
                 a.multiline == b.multiline &&
                 a.ignoreCase == b.ignoreCase;
      }
      if (typeof a != 'object' || typeof b != 'object') { return false; }
      length = stack.length;
      while (length--) { if (stack[length] == a) { return true; } }
      stack.push(a);
      size = 0;
      result = true;
      if (className == '[object Array]') {
        alength = a.length;
        blength = b.length;
        if (first) {
          switch (type) {
          case '===': result = alength === blength; break;
          case '<==': result = alength <= blength; break;
          case '<<=': result = alength < blength; break;
          }
          size = alength;
          first = false;
        } else {
          result = alength === blength;
          size = alength;
        }
        if (result) {
          while (size--) {
            if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
          }
        }
      } else {
        if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
          return false;
        }
        for (key in a) {
          if (has(a, key)) {
            size++;
            if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
          }
        }
        if (result) {
          sizeB = 0;
          for (key in b) {
            if (has(b, key)) { ++sizeB; }
          }
          if (first) {
            if (type === '<<=') {
              result = size < sizeB;
            } else if (type === '<==') {
              result = size <= sizeB
            } else {
              result = size === sizeB;
            }
          } else {
            first = false;
            result = size === sizeB;
          }
        }
      }
      stack.pop();
      return result;
    }
  }
}).call(this);
