// Generated by LiveScript 1.5.0
(function(){
  var fs, os, path, exec, ref$, log, logPad, handleExec, packWin32, packDarwin, packLinux, pack, out$ = typeof exports != 'undefined' && exports || this;
  fs = require('fs');
  os = require('os');
  path = require('path');
  exec = require('child_process').exec;
  ref$ = require('../log/std'), log = ref$.log, logPad = ref$.logPad;
  handleExec = function(err, stdout, stderr, whenDone, callback){
    if (err) {
      log('| Error when zip files');
      whenDone();
      process.exit();
    }
    if (stderr) {
      log('| Error in stderr');
      whenDone();
      process.exit();
    }
    return callback();
  };
  packWin32 = function(filePath, targetPath, whenDone, callback){
    var command;
    command = 'cd ' + targetPath;
    command += '&& zip ' + filePath + ' *';
    return exec(command, function(err, stdout, stderr){
      return handleExec(err, stdout, stderr, whenDone, callback);
    });
  };
  packDarwin = function(filePath, targetPath, whenDone, callback){
    var command;
    command = 'cd ' + targetPath;
    command += '&& zip ' + filePath + ' *';
    return exec(command, function(err, stdout, stderr){
      return handleExec(err, stdout, stderr, whenDone, callback);
    });
  };
  packLinux = function(filePath, targetPath, whenDone, callback){
    var command;
    command = 'cd ' + targetPath;
    command += '&& zip ' + filePath + ' *';
    return exec(command, function(err, stdout, stderr){
      return handleExec(err, stdout, stderr, whenDone, callback);
    });
  };
  pack = function(targetPath, packName, ghoti, whenDone, env){
    var callback, tPath, pPath;
    callback = function(){
      log('| Pack completed');
      return whenDone();
    };
    tPath = path.join(process.cwd(), targetPath);
    if (deepEq$(path.extname(packName), '.zip', '===')) {
      pPath = path.join(process.cwd(), packName);
    } else {
      pPath = path.join(process.cwd(), packName) + '.zip';
    }
    switch (os.platform()) {
    case 'win32':
      return packWin32(pPath, tPath, whenDone, callback);
    case 'darwin':
      return packDarwin(pPath, tPath, whenDone, callback);
    default:
      return packLinux(pPath, tPath, whenDone, callback);
    }
  };
  out$.pack = pack;
  function deepEq$(x, y, type){
    var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
        has = function (obj, key) { return hasOwnProperty.call(obj, key); };
    var first = true;
    return eq(x, y, []);
    function eq(a, b, stack) {
      var className, length, size, result, alength, blength, r, key, ref, sizeB;
      if (a == null || b == null) { return a === b; }
      if (a.__placeholder__ || b.__placeholder__) { return true; }
      if (a === b) { return a !== 0 || 1 / a == 1 / b; }
      className = toString.call(a);
      if (toString.call(b) != className) { return false; }
      switch (className) {
        case '[object String]': return a == String(b);
        case '[object Number]':
          return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
        case '[object Date]':
        case '[object Boolean]':
          return +a == +b;
        case '[object RegExp]':
          return a.source == b.source &&
                 a.global == b.global &&
                 a.multiline == b.multiline &&
                 a.ignoreCase == b.ignoreCase;
      }
      if (typeof a != 'object' || typeof b != 'object') { return false; }
      length = stack.length;
      while (length--) { if (stack[length] == a) { return true; } }
      stack.push(a);
      size = 0;
      result = true;
      if (className == '[object Array]') {
        alength = a.length;
        blength = b.length;
        if (first) {
          switch (type) {
          case '===': result = alength === blength; break;
          case '<==': result = alength <= blength; break;
          case '<<=': result = alength < blength; break;
          }
          size = alength;
          first = false;
        } else {
          result = alength === blength;
          size = alength;
        }
        if (result) {
          while (size--) {
            if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
          }
        }
      } else {
        if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
          return false;
        }
        for (key in a) {
          if (has(a, key)) {
            size++;
            if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
          }
        }
        if (result) {
          sizeB = 0;
          for (key in b) {
            if (has(b, key)) { ++sizeB; }
          }
          if (first) {
            if (type === '<<=') {
              result = size < sizeB;
            } else if (type === '<==') {
              result = size <= sizeB
            } else {
              result = size === sizeB;
            }
          } else {
            first = false;
            result = size === sizeB;
          }
        }
      }
      stack.pop();
      return result;
    }
  }
}).call(this);
