// Generated by LiveScript 1.5.0
(function(){
  var fs, path, log, deepClone, comments, languages, getSeparate, mapVars, replaceVar, replaceVars, libComments, libLanguages, determineLanguage, getComments, addComments, parseComments, out$ = typeof exports != 'undefined' && exports || this;
  fs = require('fs');
  path = require('path');
  log = require('../../log/std').log;
  deepClone = require('../deepclone').deepClone;
  comments = require('./commentsTemplates').comments;
  languages = require('./languageTemplates').languages;
  getSeparate = require('../../ame/osDiff').getSeparate;
  mapVars = function(vars){
    var re, i;
    re = [];
    for (i in vars) {
      re.push({
        name: i,
        value: vars[i]
      });
    }
    return re;
  };
  replaceVar = function(text, vars){
    var re, i$, len$, i;
    re = text;
    for (i$ = 0, len$ = vars.length; i$ < len$; ++i$) {
      i = vars[i$];
      re = text.replace(new RegExp('\\${\\|' + i.name + '\\|}', 'g'), i.value);
    }
    return re;
  };
  replaceVars = function(contentE, vars){
    var content, i$, to$, i;
    content = deepClone(contentE);
    for (i$ = 0, to$ = content.length - 1; i$ <= to$; ++i$) {
      i = i$;
      content[i] = replaceVar(content[i], vars);
    }
    return content;
  };
  libComments = function(type, arg$){
    var vars, re, i$, ref$, len$, i;
    if (arg$ != null) {
      vars = arg$;
    }
    if (!Boolean(vars)) {
      vars = [];
    }
    for (i$ = 0, len$ = (ref$ = comments).length; i$ < len$; ++i$) {
      i = ref$[i$];
      if (deepEq$(i.name, type, '===')) {
        re = deepClone(i.content);
      }
    }
    if (re) {
      return replaceVars(re, vars).join(getSeparate());
    } else {
      return null;
    }
  };
  libLanguages = function(language){
    var i$, ref$, len$, i;
    for (i$ = 0, len$ = (ref$ = languages).length; i$ < len$; ++i$) {
      i = ref$[i$];
      if (deepEq$(i.ext, language, '===') || deepEq$('.' + i.ext, language, '===')) {
        return i;
      }
    }
    return null;
  };
  determineLanguage = function(filename){
    var ext, lan;
    ext = path.extname(filename);
    if (deepEq$(ext, '.ghoti', '===')) {
      ext = path.extname(filename.substring(0, filename.length - 6));
    }
    lan = libLanguages(ext);
    if (lan) {
      return lan.name;
    } else {
      return null;
    }
  };
  getComments = function(filename, vars){
    var lang, adding;
    lang = determineLanguage(filename);
    switch (lang) {
    case 'javascript':
      // fallthrough
    case 'typescript':
      // fallthrough
    case 'sass':
      // fallthrough
    case 'golang':
      adding = libComments('normal', vars);
      break;
    case 'livescript':
      // fallthrough
    case 'python':
      adding = libComments('sharp', vars);
    }
    return adding;
  };
  addComments = function(filename, context, vars){
    var adding;
    adding = getComments(filename, vars);
    if (adding) {
      return adding + getSeparate() + getSeparate() + context;
    } else {
      return context;
    }
  };
  parseComments = function(filename, content, vars){
    var splited, overview;
    if (!Boolean(content.split)) {
      return content;
    }
    if (vars && !Boolean(vars.length) && !Boolean(vars.push)) {
      vars = mapVars(vars);
    }
    splited = content.split(getSeparate());
    if (deepEq$(splited[0].substring(0, 5), '// G!', '===')) {
      overview = splited[0].substring(5, splited[0].length);
      vars.push({
        name: 'overview',
        value: overview
      });
      splited[0] = getComments(filename, vars) + getSeparate();
    }
    return splited.join(getSeparate());
  };
  out$.determineLanguage = determineLanguage;
  out$.addComments = addComments;
  out$.parseComments = parseComments;
  function deepEq$(x, y, type){
    var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
        has = function (obj, key) { return hasOwnProperty.call(obj, key); };
    var first = true;
    return eq(x, y, []);
    function eq(a, b, stack) {
      var className, length, size, result, alength, blength, r, key, ref, sizeB;
      if (a == null || b == null) { return a === b; }
      if (a.__placeholder__ || b.__placeholder__) { return true; }
      if (a === b) { return a !== 0 || 1 / a == 1 / b; }
      className = toString.call(a);
      if (toString.call(b) != className) { return false; }
      switch (className) {
        case '[object String]': return a == String(b);
        case '[object Number]':
          return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
        case '[object Date]':
        case '[object Boolean]':
          return +a == +b;
        case '[object RegExp]':
          return a.source == b.source &&
                 a.global == b.global &&
                 a.multiline == b.multiline &&
                 a.ignoreCase == b.ignoreCase;
      }
      if (typeof a != 'object' || typeof b != 'object') { return false; }
      length = stack.length;
      while (length--) { if (stack[length] == a) { return true; } }
      stack.push(a);
      size = 0;
      result = true;
      if (className == '[object Array]') {
        alength = a.length;
        blength = b.length;
        if (first) {
          switch (type) {
          case '===': result = alength === blength; break;
          case '<==': result = alength <= blength; break;
          case '<<=': result = alength < blength; break;
          }
          size = alength;
          first = false;
        } else {
          result = alength === blength;
          size = alength;
        }
        if (result) {
          while (size--) {
            if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
          }
        }
      } else {
        if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
          return false;
        }
        for (key in a) {
          if (has(a, key)) {
            size++;
            if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
          }
        }
        if (result) {
          sizeB = 0;
          for (key in b) {
            if (has(b, key)) { ++sizeB; }
          }
          if (first) {
            if (type === '<<=') {
              result = size < sizeB;
            } else if (type === '<==') {
              result = size <= sizeB
            } else {
              result = size === sizeB;
            }
          } else {
            first = false;
            result = size === sizeB;
          }
        }
      }
      stack.pop();
      return result;
    }
  }
}).call(this);
