// Generated by LiveScript 1.5.0
(function(){
  var fs, path, ref$, log, logInline, version, deepClone, getInput, exec, parseComments, getSeparate, readline, processMucall, checkTypescript, commonParse, commonParseArray, commonGather, parseFile, parseAllIn, parseAll, out$ = typeof exports != 'undefined' && exports || this;
  fs = require('fs');
  path = require('path');
  ref$ = require('../../log/log'), log = ref$.log, logInline = ref$.logInline;
  version = require('../../static/static').version;
  deepClone = require('../../func/deepclone').deepClone;
  getInput = require('../../log/getInput').getInput;
  exec = require('child_process').exec;
  parseComments = require('./comments').parseComments;
  getSeparate = require('../../ame/osDiff').getSeparate;
  readline = require('readline');
  processMucall = function(env, mucall){
    var mode, i;
    env = deepClone(env);
    mucall = deepClone(mucall);
    mode = mucall.shift();
    env.mode = mode;
    for (i in mucall) {
      if (i.substring(0, !deepEq$(1, '-', '==='))) {
        env.texture.push(i);
      } else {
        log(i);
      }
    }
    return env;
  };
  checkTypescript = function(callback){
    var child;
    child = exec('tsc -v', function(err, stdout, stderr){
      if (err) {
        callback(false);
      } else {
        callback(true);
      }
    });
  };
  commonParse = function(content, vars){
    var re, i$, len$, i, reg;
    re = content;
    for (i$ = 0, len$ = vars.length; i$ < len$; ++i$) {
      i = vars[i$];
      reg = new RegExp('\\${\\|' + i.name + '\\|}', 'g');
      re = re.replace(reg, i.value);
    }
    return re;
  };
  commonParseArray = function(content, vars){
    var re, i$, len$, i, reg;
    re = content;
    for (i$ = 0, len$ = vars.length; i$ < len$; ++i$) {
      i = vars[i$];
      reg = new RegExp('\\${\\|' + i.name + '\\|}', 'g');
      re = re.replace(reg, i.value);
    }
    return re;
  };
  commonGather = function(list, done, arg$){
    var second, re, intf, rl, current, currentName, question, type, defaultValue, defaultStr;
    if (arg$ != null) {
      second = arg$;
    }
    if (!second) {
      re = [];
    } else {
      re = second;
    }
    if (list.length <= 0) {
      done([]);
      return;
    }
    intf = {
      input: process.stdin,
      output: process.stdout,
      terminal: false
    };
    rl = readline.createInterface(intf);
    current = list.shift();
    if (deepEq$(typeof current, 'string', '===')) {
      currentName = current;
      type = 'string';
      defaultValue = '';
    } else {
      currentName = current.name;
      type = current.type;
      defaultValue = current['default'];
    }
    switch (type) {
    case 'boolean':
      if (defaultValue) {
        defaultStr = 'default: Y';
      } else {
        defaultStr = 'default: N';
      }
      question = 'Gathering replace parameter "' + currentName + '" (Y/N, ' + defaultStr + ') :' + getSeparate()(+'=>> ');
      break;
    case 'string':
      // fallthrough
    default:
      if (defaultValue) {
        question = 'Gathering replace parameter "' + currentName + '" (default: ' + defaultValue + ') :' + getSeparate() + '=>> ';
      } else {
        question = 'Gathering replace parameter "' + currentName + '" :' + getSeparate() + '=>> ';
      }
    }
    rl.question(question, function(answer){
      var result;
      rl.close();
      switch (type) {
      case 'boolean':
        if (deepEq$(answer, '', '===')) {
          result = defaultValue;
        } else if (deepEq$(answer, 'Y', '===')) {
          result = true;
        } else {
          result = false;
        }
        break;
      case 'string':
        // fallthrough
      default:
        if (deepEq$(answer, '', '===')) {
          result = defaultValue;
        } else {
          result = answer;
        }
      }
      re.push({
        name: currentName,
        value: result
      });
      if (list.length > 0) {
        commonGather(list, done, re);
      } else {
        done(re);
      }
    });
  };
  parseFile = function(filename, text, vars, specVars, arg$){
    var typescript, re, i;
    if (arg$ != null) {
      typescript = arg$;
    }
    re = text;
    re = parseComments(filename, text, vars);
    re = re.replace(/\${\|version\|}/g, version);
    if (deepEq$(filename, 'package.json.ghoti', '===') || deepEq$(filename, 'README.md.ghoti', '===')) {
      if (typescript) {
        re = re.replace(/\${\|typescript\|}/g, '"typescript": "^2.7.2",');
      } else {
        re = re.replace(/\${\|typescript\|}/g, '');
      }
      re = re.replace(/\${\|readme\|}/g, '');
      if (vars.open) {
        re = re.replace(/\${\|private\|}/g, 'false');
        re = re.replace(/\${\|license\|}/g, 'MIT');
      } else {
        re = re.replace(/\${\|private\|}/g, 'true');
        re = re.replace(/\${\|license\|}/g, 'PRIVATE');
      }
    }
    for (i in vars) {
      switch (i) {
      case 'title':
        re = re.replace(/\${\|title\|}/g, vars.title);
        break;
      case 'description':
        re = re.replace(/\${\|description\|}/g, vars.description);
        break;
      case 'author':
        re = re.replace(/\${\|author\|}/g, vars.author);
      }
    }
    re = commonParse(re, specVars);
    return re;
  };
  parseAllIn = function(textList, vars){
    return vars;
  };
  parseAll = function(textList, targetPath, env, callback){
    return checkTypescript(function(typescriptExist){
      var vars, titleQuestionText;
      vars = {
        title: '',
        description: '',
        author: '',
        open: false
      };
      log('✒️  More about your awesome project~');
      titleQuestionText = 'Project Title';
      getInput(titleQuestionText, targetPath, function(title){
        var descriptionQuestionText;
        vars.title = title;
        descriptionQuestionText = 'Descriptions of ' + vars.title;
        getInput(descriptionQuestionText, '', function(description){
          var authorQuestionText;
          vars.description = description;
          authorQuestionText = 'Author of ' + vars.title;
          getInput(authorQuestionText, '', function(author){
            var openQuestionText;
            vars.author = author;
            openQuestionText = 'Is ' + vars.title + ' is an open source project?';
            getInput(openQuestionText, false, function(open){
              vars.open = open;
              return callback(parseAllIn(textList, vars), typescriptExist);
            });
          });
        });
      });
    });
  };
  out$.processMucall = processMucall;
  out$.parseFile = parseFile;
  out$.commonParse = commonParse;
  out$.commonGather = commonGather;
  out$.parseAll = parseAll;
  out$.checkTypescript = checkTypescript;
  function deepEq$(x, y, type){
    var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
        has = function (obj, key) { return hasOwnProperty.call(obj, key); };
    var first = true;
    return eq(x, y, []);
    function eq(a, b, stack) {
      var className, length, size, result, alength, blength, r, key, ref, sizeB;
      if (a == null || b == null) { return a === b; }
      if (a.__placeholder__ || b.__placeholder__) { return true; }
      if (a === b) { return a !== 0 || 1 / a == 1 / b; }
      className = toString.call(a);
      if (toString.call(b) != className) { return false; }
      switch (className) {
        case '[object String]': return a == String(b);
        case '[object Number]':
          return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
        case '[object Date]':
        case '[object Boolean]':
          return +a == +b;
        case '[object RegExp]':
          return a.source == b.source &&
                 a.global == b.global &&
                 a.multiline == b.multiline &&
                 a.ignoreCase == b.ignoreCase;
      }
      if (typeof a != 'object' || typeof b != 'object') { return false; }
      length = stack.length;
      while (length--) { if (stack[length] == a) { return true; } }
      stack.push(a);
      size = 0;
      result = true;
      if (className == '[object Array]') {
        alength = a.length;
        blength = b.length;
        if (first) {
          switch (type) {
          case '===': result = alength === blength; break;
          case '<==': result = alength <= blength; break;
          case '<<=': result = alength < blength; break;
          }
          size = alength;
          first = false;
        } else {
          result = alength === blength;
          size = alength;
        }
        if (result) {
          while (size--) {
            if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
          }
        }
      } else {
        if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
          return false;
        }
        for (key in a) {
          if (has(a, key)) {
            size++;
            if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
          }
        }
        if (result) {
          sizeB = 0;
          for (key in b) {
            if (has(b, key)) { ++sizeB; }
          }
          if (first) {
            if (type === '<<=') {
              result = size < sizeB;
            } else if (type === '<==') {
              result = size <= sizeB
            } else {
              result = size === sizeB;
            }
          } else {
            first = false;
            result = size === sizeB;
          }
        }
      }
      stack.pop();
      return result;
    }
  }
}).call(this);
