// Generated by LiveScript 1.5.0
(function(){
  var fs, path, config, ref$, updateConfig, cliPath, log, logHelp, logHelpMore, logInfo, logPostNPMInstall, logAbout, logUnderline, logVersion, logCommand, logSymbol, logUnknown, logStatus, logWhatIs, logUpdate, logList, logListPlus, logFileList, logGame, logGameCommand, logDeprecated, logTilde, argv, ghotiConfig, init, downloadArchive, component, page, lambda, func, feature, executeBkc, processMucall, fix, update, initUnderline, checkAme, executeAme, minigame, frogGame, file, suffix, pack, addTilde, executeTilde, notValid, runPrefixCommand, execute, out$ = typeof exports != 'undefined' && exports || this;
  fs = require('fs');
  path = require('path');
  config = require('./func/config');
  ref$ = require('./func/config'), updateConfig = ref$.updateConfig, cliPath = ref$.cliPath;
  ref$ = require('./log/log'), log = ref$.log, logHelp = ref$.logHelp, logHelpMore = ref$.logHelpMore, logInfo = ref$.logInfo, logPostNPMInstall = ref$.logPostNPMInstall, logAbout = ref$.logAbout, logUnderline = ref$.logUnderline, logVersion = ref$.logVersion, logCommand = ref$.logCommand, logSymbol = ref$.logSymbol, logUnknown = ref$.logUnknown, logStatus = ref$.logStatus, logWhatIs = ref$.logWhatIs, logUpdate = ref$.logUpdate, logList = ref$.logList, logListPlus = ref$.logListPlus, logFileList = ref$.logFileList, logGame = ref$.logGame, logGameCommand = ref$.logGameCommand, logDeprecated = ref$.logDeprecated, logTilde = ref$.logTilde;
  ref$ = require('./func/argv'), argv = ref$.argv, ghotiConfig = ref$.ghotiConfig;
  ref$ = require('./func/init'), init = ref$.init, downloadArchive = ref$.downloadArchive;
  component = require('./structure/component').component;
  page = require('./structure/page').page;
  lambda = require('./structure/lambda').lambda;
  func = require('./structure/func').func;
  feature = require('./structure/feature').feature;
  executeBkc = require('./func/bark').executeBkc;
  processMucall = require('./func/parser/parser').processMucall;
  fix = require('./func/fix').fix;
  update = require('./func/update').update;
  initUnderline = require('./ame/init').initUnderline;
  ref$ = require('./ame/execute'), checkAme = ref$.checkAme, executeAme = ref$.executeAme;
  minigame = require('./eng/init').minigame;
  frogGame = require('./eng/frog').frogGame;
  file = require('./func/file').file;
  suffix = require('./func/suffix').suffix;
  pack = require('./func/pack').pack;
  ref$ = require('./ame/tilde/tilde'), addTilde = ref$.addTilde, executeTilde = ref$.executeTilde;
  notValid = function(env){
    logUnknown(env);
    return process.exit();
  };
  runPrefixCommand = function(command, ghoti, ghotiCLIPath, env){
    var whenDone, prefix, suffix, ameResult;
    if (!Boolean(command)) {
      notValid(env);
    }
    if (!deepEq$(typeof command, 'string', '===')) {
      notValid(env);
    }
    if (command.length < 1) {
      notValid(env);
    }
    prefix = command.substring(0, 1);
    suffix = command.substring(1, command.length);
    switch (prefix) {
    case '_':
      ameResult = checkAme(command);
      if (ameResult) {
        return executeAme(ameResult, env.texture, ghoti, logSymbol, env, ghotiCLIPath, process.cwd());
      } else {
        return notValid(env);
      }
      break;
    case '!':
      whenDone = logGameCommand();
      return frogGame(ghoti, env, whenDone);
    case '=':
      return logWhatIs(suffix, env);
    case '~':
      whenDone = logTilde();
      return executeTilde(suffix, env, whenDone);
    default:
      return notValid(env);
    }
  };
  execute = function(){
    var ref$, res$, i$, to$, mucall, whenDone, env, ghoti, ghotiCLIPath, mode;
    res$ = [];
    for (i$ = 0, to$ = arguments.length; i$ < to$; ++i$) {
      res$.push(arguments[i$]);
    }
    ref$ = res$; if (ref$ != null) {
      mucall = ref$;
    };
    ghoti = ghotiConfig;
    ghotiCLIPath = cliPath();
    env = argv();
    if (env) {
      if (mucall.length >= 1) {
        env = processMucall(env, mucall);
      }
    } else {
      log('| Environment process Error');
      log('| Try "ghoti fix"');
      process.exit();
    }
    mode = env.mode.toLowerCase();
    switch (mode) {
    case 'a':
      // fallthrough
    case 'about':
      logAbout(env);
      break;
    case 'b':
      // fallthrough
    case 'bk':
      // fallthrough
    case 'bark':
      executeBkc(env.texture[0]);
      break;
    case 'empty':
      logHelp(true, env);
      break;
    case 'v':
      // fallthrough
    case 'version':
      logVersion(env);
      break;
    case '?':
      // fallthrough
    case 'help':
      logHelp(false, env);
      break;
    case '?+':
      // fallthrough
    case 'help+':
      logHelpMore(env);
      break;
    case 'stat':
      // fallthrough
    case 'status':
      logStatus(ghoti, env);
      break;
    case 'd':
      // fallthrough
    case 'install':
      // fallthrough
    case 'download':
      whenDone = logCommand();
      downloadArchive(ghotiCLIPath, env.texture[0], env.texture[1], whenDone, env);
      break;
    case 'inf':
      // fallthrough
    case 'info':
      logInfo(env.texture[0], env);
      break;
    case 'i':
      logDeprecated('i', ['Confusing between "init" and "install"']);
      break;
    case 'create':
      // fallthrough
    case 'new':
      // fallthrough
    case 'template':
      // fallthrough
    case 'init':
      whenDone = logCommand();
      init(ghotiCLIPath, env.texture[0], env.texture[1], whenDone, env);
      break;
    case 'merge':
      // fallthrough
    case 'mer':
      // fallthrough
    case 'm':
      whenDone = logCommand();
      log('Not a finished feature, check update');
      whenDone();
      break;
    case 'f':
      // fallthrough
    case 'file':
      whenDone = logCommand();
      file(ghotiCLIPath, env.texture[0], env.texture[1], whenDone, env);
      break;
    case 'example':
      whenDone = logCommand();
      init(ghotiCLIPath, 'ghoti-example', env.texture[0], whenDone, env);
      break;
    case 'update':
      whenDone = logUpdate(ghoti, env);
      update(whenDone, env);
      break;
    case '~':
      // fallthrough
    case 'tilde':
      whenDone = logTilde();
      addTilde(whenDone);
      break;
    case 'w':
      // fallthrough
    case '=':
      // fallthrough
    case 'whatIs':
      // fallthrough
    case 'what':
      // fallthrough
    case 'whatis':
      logWhatIs(env.texture[0], env);
      break;
    case 'lt':
      // fallthrough
    case 'types':
      // fallthrough
    case 'list':
      logList(env);
      break;
    case 'lt+':
      // fallthrough
    case 'types+':
      // fallthrough
    case 'listPlus':
      // fallthrough
    case 'list+':
      logListPlus(env);
      break;
    case 'lf':
      // fallthrough
    case 'files':
      // fallthrough
    case 'listFile':
      logFileList(env);
      break;
    case 'issue':
      // fallthrough
    case 'fix':
      whenDone = logCommand();
      fix(env.texture, ghoti, whenDone, env);
      break;
    case 'hint':
      // fallthrough
    case 'post':
      logPostNPMInstall(env.texture[0], env);
      break;
    case 'suffix':
      // fallthrough
    case 'suff':
      // fallthrough
    case 'suf':
      // fallthrough
    case 's':
      whenDone = logCommand();
      suffix(env.texture[0], env.texture[1], ghoti, whenDone, env);
      break;
    case 'pack':
      // fallthrough
    case 'p':
      whenDone = logCommand();
      pack(env.texture[0], env.texture[1], ghoti, whenDone, env);
      break;
    case 'deploy':
      // fallthrough
    case 's&p':
      whenDone = logCommand();
      suffix(env.texture[0], env.texture[1], ghoti, function(){
        pack(env.texture[0], env.texture[1], ghoti, whenDone, env);
      }, env);
      break;
    case '+l':
      // fallthrough
    case 'lambda':
      whenDone = logCommand();
      lambda(ghotiCLIPath, process.cwd(), env.texture[0], ghoti, whenDone, env);
      whenDone();
      break;
    case '+t':
      // fallthrough
    case 'feature':
      whenDone = logCommand();
      feature(ghotiCLIPath, process.cwd(), env.texture[0], ghoti, whenDone, env);
      whenDone();
      break;
    case '+f':
      // fallthrough
    case 'func':
      whenDone = logCommand();
      func(ghotiCLIPath, process.cwd(), env.texture[0], ghoti, whenDone, env);
      whenDone();
      break;
    case 'function':
      whenDone = logCommand('function', 'func');
      func(ghotiCLIPath, process.cwd(), env.texture[0], ghoti, whenDone, env);
      whenDone();
      break;
    case '+p':
      // fallthrough
    case 'page':
      whenDone = logCommand();
      page(ghotiCLIPath, process.cwd(), env.texture[0], ghoti, whenDone, env);
      whenDone();
      break;
    case '+c':
      // fallthrough
    case 'component':
      whenDone = logCommand();
      component(ghotiCLIPath, process.cwd(), env.texture[0], ghoti, whenDone, env);
      whenDone();
      break;
    case 'underline':
      whenDone = logUnderline();
      initUnderline(ghoti, whenDone, env);
      break;
    case 'g':
      // fallthrough
    case 'game':
      // fallthrough
    case 'minigame':
      whenDone = logGame();
      minigame(ghoti, env, whenDone);
      break;
    default:
      runPrefixCommand(mode, ghoti, ghotiCLIPath, env);
    }
  };
  out$.execute = execute;
  function deepEq$(x, y, type){
    var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
        has = function (obj, key) { return hasOwnProperty.call(obj, key); };
    var first = true;
    return eq(x, y, []);
    function eq(a, b, stack) {
      var className, length, size, result, alength, blength, r, key, ref, sizeB;
      if (a == null || b == null) { return a === b; }
      if (a.__placeholder__ || b.__placeholder__) { return true; }
      if (a === b) { return a !== 0 || 1 / a == 1 / b; }
      className = toString.call(a);
      if (toString.call(b) != className) { return false; }
      switch (className) {
        case '[object String]': return a == String(b);
        case '[object Number]':
          return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
        case '[object Date]':
        case '[object Boolean]':
          return +a == +b;
        case '[object RegExp]':
          return a.source == b.source &&
                 a.global == b.global &&
                 a.multiline == b.multiline &&
                 a.ignoreCase == b.ignoreCase;
      }
      if (typeof a != 'object' || typeof b != 'object') { return false; }
      length = stack.length;
      while (length--) { if (stack[length] == a) { return true; } }
      stack.push(a);
      size = 0;
      result = true;
      if (className == '[object Array]') {
        alength = a.length;
        blength = b.length;
        if (first) {
          switch (type) {
          case '===': result = alength === blength; break;
          case '<==': result = alength <= blength; break;
          case '<<=': result = alength < blength; break;
          }
          size = alength;
          first = false;
        } else {
          result = alength === blength;
          size = alength;
        }
        if (result) {
          while (size--) {
            if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
          }
        }
      } else {
        if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
          return false;
        }
        for (key in a) {
          if (has(a, key)) {
            size++;
            if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
          }
        }
        if (result) {
          sizeB = 0;
          for (key in b) {
            if (has(b, key)) { ++sizeB; }
          }
          if (first) {
            if (type === '<<=') {
              result = size < sizeB;
            } else if (type === '<==') {
              result = size <= sizeB
            } else {
              result = size === sizeB;
            }
          } else {
            first = false;
            result = size === sizeB;
          }
        }
      }
      stack.pop();
      return result;
    }
  }
}).call(this);
