// Generated by LiveScript 1.5.0
(function(){
  var readline, inputStream, outputStream, getDisplayLength, getStrOccRowColumns, log, dlog, logInline, logPad, logHalfPad, forceEnter, logReplace, out$ = typeof exports != 'undefined' && exports || this;
  readline = require('readline');
  inputStream = process.stdin;
  outputStream = process.stdout;
  getDisplayLength = function(str){
    var realLength, len, i$, to$, i, charCode;
    realLength = 0;
    len = str.length;
    for (i$ = 0, to$ = len - 1; i$ <= to$; ++i$) {
      i = i$;
      charCode = str.charCodeAt(i);
      if (charCode >= 0 && charCode <= 128) {
        realLength += 1;
      } else {
        realLength += 2;
      }
    }
    return realLength;
  };
  getStrOccRowColumns = function(str){
    var consoleMaxRows, consoleMaxColumns, strDisplayLength, rows, columns;
    consoleMaxRows = outputStream.rows;
    consoleMaxColumns = outputStream.columns;
    strDisplayLength = getDisplayLength(str);
    rows = parseInt(strDisplayLength / consoleMaxColumns, 10);
    columns = parseInt(strDisplayLength - rows * consoleMaxColumns, 10);
    return {
      rows: rows,
      columns: columns
    };
  };
  log = function(){
    var text, res$, i$, to$;
    res$ = [];
    for (i$ = 0, to$ = arguments.length; i$ < to$; ++i$) {
      res$.push(arguments[i$]);
    }
    text = res$;
    console.log.apply(console, text);
    return text;
  };
  dlog = function(env){
    var text, res$, i$, to$;
    res$ = [];
    for (i$ = 1, to$ = arguments.length; i$ < to$; ++i$) {
      res$.push(arguments[i$]);
    }
    text = res$;
    if (deepEq$(typeof env, 'string', '===')) {
      log('| Error usage of dlog');
    }
    if (Boolean(env)) {
      if (env.debug) {
        return log(text);
      }
    }
  };
  logInline = function(text){
    process.stdout.write(text);
    return text;
  };
  logPad = function(text, arg$){
    var pad, i$, i;
    if (arg$ != null) {
      pad = arg$;
    }
    if (pad) {
      for (i$ = 0; i$ <= pad; ++i$) {
        i = i$;
        text = '  ' + text;
      }
    }
    log(text);
    return text;
  };
  logHalfPad = function(text, arg$){
    var pad, i$, i;
    if (arg$ != null) {
      pad = arg$;
    }
    if (pad) {
      for (i$ = 0; i$ <= pad; ++i$) {
        i = i$;
        text = ' ' + text;
      }
    }
    log(text);
    return text;
  };
  forceEnter = function(){
    outputStream.write('\r\n');
  };
  logReplace = function(content, arg$){
    var lastContent, dxInfo, cursorDx, cursorDy, output;
    if (arg$ != null) {
      lastContent = arg$;
    }
    if (lastContent) {
      dxInfo = getStrOccRowColumns(lastContent.toString());
    } else {
      dxInfo = {
        columns: 0,
        rows: 0
      };
    }
    cursorDx = dxInfo.columns;
    cursorDy = dxInfo.rows;
    output = content.toString();
    readline.moveCursor(outputStream, cursorDx * -1, cursorDy * -1);
    readline.clearScreenDown(outputStream);
    outputStream.write(output);
  };
  out$.log = log;
  out$.dlog = dlog;
  out$.logPad = logPad;
  out$.logHalfPad = logHalfPad;
  out$.logInline = logInline;
  out$.logReplace = logReplace;
  out$.forceEnter = forceEnter;
  function deepEq$(x, y, type){
    var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
        has = function (obj, key) { return hasOwnProperty.call(obj, key); };
    var first = true;
    return eq(x, y, []);
    function eq(a, b, stack) {
      var className, length, size, result, alength, blength, r, key, ref, sizeB;
      if (a == null || b == null) { return a === b; }
      if (a.__placeholder__ || b.__placeholder__) { return true; }
      if (a === b) { return a !== 0 || 1 / a == 1 / b; }
      className = toString.call(a);
      if (toString.call(b) != className) { return false; }
      switch (className) {
        case '[object String]': return a == String(b);
        case '[object Number]':
          return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
        case '[object Date]':
        case '[object Boolean]':
          return +a == +b;
        case '[object RegExp]':
          return a.source == b.source &&
                 a.global == b.global &&
                 a.multiline == b.multiline &&
                 a.ignoreCase == b.ignoreCase;
      }
      if (typeof a != 'object' || typeof b != 'object') { return false; }
      length = stack.length;
      while (length--) { if (stack[length] == a) { return true; } }
      stack.push(a);
      size = 0;
      result = true;
      if (className == '[object Array]') {
        alength = a.length;
        blength = b.length;
        if (first) {
          switch (type) {
          case '===': result = alength === blength; break;
          case '<==': result = alength <= blength; break;
          case '<<=': result = alength < blength; break;
          }
          size = alength;
          first = false;
        } else {
          result = alength === blength;
          size = alength;
        }
        if (result) {
          while (size--) {
            if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
          }
        }
      } else {
        if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
          return false;
        }
        for (key in a) {
          if (has(a, key)) {
            size++;
            if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
          }
        }
        if (result) {
          sizeB = 0;
          for (key in b) {
            if (has(b, key)) { ++sizeB; }
          }
          if (first) {
            if (type === '<<=') {
              result = size < sizeB;
            } else if (type === '<==') {
              result = size <= sizeB
            } else {
              result = size === sizeB;
            }
          } else {
            first = false;
            result = size === sizeB;
          }
        }
      }
      stack.pop();
      return result;
    }
  }
}).call(this);
