// Generated by LiveScript 1.5.0
(function(){
  var path, fs, os, spawn, ref$, writeCLIConfig, readCLIConfig, log, logPad, deepClone, uniqueId, downloadFile, readFileC, downloadPack, parseLink, expendPack, addExternal, addRemote, checkGhotiFile, executeSwitch, executeExternalFile, executeExternal, archiveLinux, archiveDarwin, archiveWin32, unlinkFile, out$ = typeof exports != 'undefined' && exports || this;
  path = require('path');
  fs = require('fs');
  os = require('os');
  spawn = require('child_process').spawn;
  ref$ = require('../../func/config'), writeCLIConfig = ref$.writeCLIConfig, readCLIConfig = ref$.readCLIConfig;
  ref$ = require('../../log/std'), log = ref$.log, logPad = ref$.logPad;
  ref$ = require('../../func/deepclone'), deepClone = ref$.deepClone, uniqueId = ref$.uniqueId;
  downloadFile = require('./download').downloadFile;
  readFileC = require('../../func/fs/fileController').readFileC;
  downloadPack = function(uri, filename, callback){
    downloadFile(uri, filename, function(err){
      if (err) {
        log('| Err ' + err.toString());
        process.exit();
      } else {
        callback();
      }
    });
  };
  parseLink = function(linkE, whenDone){
    var splited, protocol, link, next;
    splited = linkE.split(/:\/\/|\//g);
    if (splited.length <= 0) {
      log('| Not a valid link');
      whenDone();
      process.exit();
    }
    protocol = splited.shift().toLowerCase();
    switch (protocol) {
    case 'github':
      next = 'download';
      link = 'https://raw.githubusercontent.com/' + splited.join('/');
      break;
    case 'http':
      // fallthrough
    case 'https':
      next = 'download';
      link = linkE;
      break;
    case 'file':
      next = 'file';
      link = linkE;
      break;
    default:
      log('| Not a valid link');
      whenDone();
      process.exit();
    }
    return {
      next: next,
      link: link
    };
  };
  expendPack = function(filePath, targetPath, whenDone, callback){
    switch (os.platform()) {
    case 'win32':
      return archiveWin32(filePath, targetPath, whenDone, callback);
    case 'darwin':
      return archiveDarwin(filePath, targetPath, whenDone, callback);
    default:
      return archiveLinux(filePath, targetPath, whenDone, callback);
    }
  };
  addExternal = function(cliConfigE, ghotiinstallE, expackPath, whenDone){
    var cliConfig, i$, ref$, len$, i, ghotiinstall;
    cliConfig = deepClone(cliConfigE);
    if (cliConfig.external) {
      if (cliConfig.external.length) {
        for (i$ = 0, len$ = (ref$ = cliConfig.external).length; i$ < len$; ++i$) {
          i = ref$[i$];
          if (deepEq$(i.name, ghotiinstallE.name, '===')) {
            log('| ghotiinstall name already exist');
            whenDone();
            process.exit();
          }
        }
      }
    } else {
      log('| CLI config file is not valid');
      whenDone();
      process.exit();
    }
    ghotiinstall = deepClone(ghotiinstallE);
    ghotiinstall.path = expackPath;
    cliConfig.external.push(ghotiinstall);
    writeCLIConfig(cliConfig);
  };
  addRemote = function(cliConfigE, ghotiinstallE, expackPath, whenDone){
    var cliConfig, i$, ref$, len$, i, ghotiinstall;
    cliConfig = deepClone(cliConfigE);
    if (cliConfig.remote) {
      if (cliConfig.remote.length) {
        for (i$ = 0, len$ = (ref$ = cliConfig.remote).length; i$ < len$; ++i$) {
          i = ref$[i$];
          if (deepEq$(i.name, ghotiinstallE.name, '===')) {
            log('| ghotiinstall name already exist');
            whenDone();
            process.exit();
          }
        }
      }
    } else {
      log('| CLI config file is not valid');
      whenDone();
      process.exit();
    }
    ghotiinstall = deepClone(ghotiinstallE);
    ghotiinstall.path = expackPath;
    cliConfig.remote.push(ghotiinstall);
    writeCLIConfig(cliConfig);
  };
  checkGhotiFile = function(whenDone){
    var cliConfig, external;
    cliConfig = readCLIConfig();
    if (cliConfig.external && cliConfig.remote) {} else {
      log('| ghoti config file is not exist in storage list');
      log('| Try to reinstall ghoti-cli by "sudo npm -g install ghoti-cli"');
      whenDone();
      process.exit();
    }
    return cliConfig;
  };
  executeSwitch = function(ghoti_path, opit, targetPath, whenDone, env, callback){
    var cliConfig, ref$, link, next, id, downloadPath, expendPath;
    cliConfig = checkGhotiFile(whenDone);
    ref$ = parseLink(opit, whenDone), link = ref$.link, next = ref$.next;
    switch (next) {
    case 'download':
      id = uniqueId();
      downloadPath = path.join(ghoti_path, 'external', 'cache', id + '.zip');
      expendPath = path.join(ghoti_path, 'external', 'external', id);
      downloadPack(link, downloadPath, function(){
        log('--- DOWNLOAD COMPLETED ---');
        log('| PACKAGE UNIQUEID: ' + id);
        return expendPack(downloadPath, expendPath, whenDone, function(ghotiinstall){
          if (deepEq$(ghotiinstall.type, 'file', '===')) {
            addRemote(cliConfig, ghotiinstall, expendPath, whenDone);
            return callback(expendPath, ghotiinstall);
          } else if (deepEq$(ghotiinstall.type, 'template', '===')) {
            addExternal(cliConfig, ghotiinstall, expendPath, whenDone);
            return callback(expendPath, ghotiinstall);
          } else {
            log('| External package is too old, this may not supported in future version');
            addExternal(cliConfig, ghotiinstall, expendPath, whenDone);
            return callback(expendPath, ghotiinstall);
          }
        });
      });
      break;
    case 'file':
      log(next);
      break;
    default:
      log('| Not a valid link');
      whenDone();
      process.exit();
    }
  };
  executeExternalFile = function(ghoti_path, fileName, targetPath, whenDone, env, callback){
    var cliConfig, ref$, link, next, id, downloadPath, expendPath;
    cliConfig = checkGhotiFile(whenDone);
    ref$ = parseLink(fileName, whenDone), link = ref$.link, next = ref$.next;
    switch (next) {
    case 'download':
      id = uniqueId();
      downloadPath = path.join(ghoti_path, 'external', 'cache', id + '.zip');
      expendPath = path.join(ghoti_path, 'external', 'external', id);
      downloadPack(link, downloadPath, function(){
        log('--- DOWNLOAD COMPLETED ---');
        log('| PACKAGE UNIQUEID: ' + id);
        return expendPack(downloadPath, expendPath, whenDone, function(ghotiinstall){
          if (!deepEq$(ghotiinstall.type, 'file', '===')) {
            log('| Expended Package is not a Ghoti Remote File');
            whenDone();
            process.exit();
          }
          addRemote(cliConfig, ghotiinstall, expendPath, whenDone);
          return callback(expendPath, ghotiinstall);
        });
      });
      break;
    case 'file':
      log(next);
      break;
    default:
      log('| Not a valid link');
      whenDone();
      process.exit();
    }
  };
  executeExternal = function(ghoti_path, type, targetPath, whenDone, env, callback){
    var cliConfig, ref$, link, next, id, downloadPath, expendPath;
    cliConfig = checkGhotiFile(whenDone);
    ref$ = parseLink(type, whenDone), link = ref$.link, next = ref$.next;
    switch (next) {
    case 'download':
      id = uniqueId();
      downloadPath = path.join(ghoti_path, 'external', 'cache', id + '.zip');
      expendPath = path.join(ghoti_path, 'external', 'external', id);
      downloadPack(link, downloadPath, function(){
        log('--- DOWNLOAD COMPLETED ---');
        log('| PACKAGE UNIQUEID: ' + id);
        return expendPack(downloadPath, expendPath, whenDone, function(ghotiinstall){
          if (!ghotiinstall.type) {
            log('| External package is too old, this may not supported in future version');
          } else if (!deepEq$(ghotiinstall.type, 'template', '===')) {
            log('| Expended Package is not a Ghoti External Package');
            whenDone();
            process.exit();
          }
          addExternal(cliConfig, ghotiinstall, expendPath, whenDone);
          return callback(expendPath, ghotiinstall);
        });
      });
      break;
    case 'file':
      log(next);
      break;
    default:
      log('| Not a valid link');
      whenDone();
      process.exit();
    }
  };
  archiveLinux = function(filePath, targetPath, whenDone, callback){
    var unzip;
    unzip = spawn('unzip', ['-o', filePath, '-d', targetPath]);
    unzip.on('exit', function(code){
      var tempFilePath;
      if (deepEq$(code, 0, '===')) {
        log('---  UNPACK COMPLETED  ---');
        tempFilePath = path.join(targetPath, '.ghotiinstall');
        if (fs.existsSync(tempFilePath)) {
          return callback(JSON.parse(readFileC(tempFilePath, 'utf8')));
        } else {
          tempFilePath = path.join(targetPath, '.ghotiinstall.ghoti');
          if (fs.existsSync(tempFilePath)) {
            return callback(JSON.parse(readFileC(tempFilePath, 'utf8')));
          } else {
            log('| Target pack have no .ghotiinstall file');
            whenDone();
            return process.exit();
          }
        }
      } else {
        log('| Unzip failed');
        log('--- Cleaning ---');
        whenDone();
        return process.exit();
      }
    });
  };
  archiveDarwin = function(filePath, targetPath, whenDone, callback){
    var unzip;
    unzip = spawn('unzip', ['-o', filePath, '-d', targetPath]);
    unzip.on('exit', function(code){
      var tempFilePath;
      if (deepEq$(code, 0, '===')) {
        log('---  UNPACK COMPLETED  ---');
        tempFilePath = path.join(targetPath, '.ghotiinstall');
        if (fs.existsSync(tempFilePath)) {
          return callback(JSON.parse(readFileC(tempFilePath, 'utf8')));
        } else {
          tempFilePath = path.join(targetPath, '.ghotiinstall.ghoti');
          if (fs.existsSync(tempFilePath)) {
            return callback(JSON.parse(readFileC(tempFilePath, 'utf8')));
          } else {
            log('| Target pack have no .ghotiinstall file');
            whenDone();
            return process.exit();
          }
        }
      } else {
        log('| Unzip failed');
        whenDone();
        return process.exit();
      }
    });
  };
  archiveWin32 = function(filePath, targetPath, whenDone, callback){
    var unzip;
    unzip = spawn('unzip', ['-o', filePath, '-d', targetPath]);
    unzip.on('exit', function(code){
      var tempFilePath;
      if (deepEq$(code, 0, '===')) {
        log('---  UNPACK COMPLETED  ---');
        tempFilePath = path.join(targetPath, '.ghotiinstall');
        if (fs.existsSync(tempFilePath)) {
          return callback(JSON.parse(readFileC(tempFilePath, 'utf8')));
        } else {
          tempFilePath = path.join(targetPath, '.ghotiinstall.ghoti');
          if (fs.existsSync(tempFilePath)) {
            return callback(JSON.parse(readFileC(tempFilePath, 'utf8')));
          } else {
            log('| Target pack have no .ghotiinstall file');
            whenDone();
            return process.exit();
          }
        }
      } else {
        log('| Unzip failed');
        whenDone();
        return process.exit();
      }
    });
  };
  unlinkFile = function(filePath, whenDone){
    fs.unlinkSync(filePath);
  };
  out$.parseLink = parseLink;
  out$.executeSwitch = executeSwitch;
  out$.executeExternal = executeExternal;
  out$.executeExternalFile = executeExternalFile;
  function deepEq$(x, y, type){
    var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
        has = function (obj, key) { return hasOwnProperty.call(obj, key); };
    var first = true;
    return eq(x, y, []);
    function eq(a, b, stack) {
      var className, length, size, result, alength, blength, r, key, ref, sizeB;
      if (a == null || b == null) { return a === b; }
      if (a.__placeholder__ || b.__placeholder__) { return true; }
      if (a === b) { return a !== 0 || 1 / a == 1 / b; }
      className = toString.call(a);
      if (toString.call(b) != className) { return false; }
      switch (className) {
        case '[object String]': return a == String(b);
        case '[object Number]':
          return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
        case '[object Date]':
        case '[object Boolean]':
          return +a == +b;
        case '[object RegExp]':
          return a.source == b.source &&
                 a.global == b.global &&
                 a.multiline == b.multiline &&
                 a.ignoreCase == b.ignoreCase;
      }
      if (typeof a != 'object' || typeof b != 'object') { return false; }
      length = stack.length;
      while (length--) { if (stack[length] == a) { return true; } }
      stack.push(a);
      size = 0;
      result = true;
      if (className == '[object Array]') {
        alength = a.length;
        blength = b.length;
        if (first) {
          switch (type) {
          case '===': result = alength === blength; break;
          case '<==': result = alength <= blength; break;
          case '<<=': result = alength < blength; break;
          }
          size = alength;
          first = false;
        } else {
          result = alength === blength;
          size = alength;
        }
        if (result) {
          while (size--) {
            if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
          }
        }
      } else {
        if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
          return false;
        }
        for (key in a) {
          if (has(a, key)) {
            size++;
            if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
          }
        }
        if (result) {
          sizeB = 0;
          for (key in b) {
            if (has(b, key)) { ++sizeB; }
          }
          if (first) {
            if (type === '<<=') {
              result = size < sizeB;
            } else if (type === '<==') {
              result = size <= sizeB
            } else {
              result = size === sizeB;
            }
          } else {
            first = false;
            result = size === sizeB;
          }
        }
      }
      stack.pop();
      return result;
    }
  }
}).call(this);
