// Generated by LiveScript 1.5.0
(function(){
  var fs, path, ref$, comments, verifyNameValidation, libComponent, pathBuilder, log, logPad, updateConfig, readFileC, ghotiComponentClassName, ghotiComponentFileName, ghotiComponentExport, ghotiComponentExportVue, readFile, comImport, comVueAddon, component, out$ = typeof exports != 'undefined' && exports || this;
  fs = require('fs');
  path = require('path');
  ref$ = require('./common'), comments = ref$.comments, verifyNameValidation = ref$.verifyNameValidation;
  ref$ = require('./lib/lib'), libComponent = ref$.libComponent, pathBuilder = ref$.pathBuilder;
  ref$ = require('../log/log'), log = ref$.log, logPad = ref$.logPad;
  updateConfig = require('../func/config').updateConfig;
  readFileC = require('../func/fs/fileController').readFileC;
  ghotiComponentClassName = function(name){
    return "ComponentGhoti" + name.substring(0, 1).toUpperCase() + name.substring(1, name.length);
  };
  ghotiComponentFileName = function(name, arg$){
    var vue;
    if (arg$ != null) {
      vue = arg$;
    }
    if (vue) {
      return name + '.component.vue';
    } else {
      return name + ".component";
    }
  };
  ghotiComponentExport = function(name){
    return "    " + ghotiComponentClassName(name) + " as " + name;
  };
  ghotiComponentExportVue = function(name){
    return "        Vue.component('" + name + "', " + ghotiComponentClassName(name) + ");";
  };
  readFile = function(root, name, ghoti){
    var re;
    re = readFileC(root, 'utf8').toString();
    re = re.replace(/\${\|component\|}/g, ghotiComponentClassName(name));
    re = re.replace(/\${\|author\|}/g, ghoti.author || "unknown");
    return re;
  };
  comImport = function(ghoti){
    var re;
    if (!Boolean(ghoti.components)) {
      log('ERROR, ghoti have no components configuration');
      log('Try to fix it: "ghoti fix"');
      process.exit();
    }
    re = comments('components');
    re += ghoti.components.map(function(it){
      return "import " + ghotiComponentClassName(it) + " from './" + ghotiComponentFileName(it) + "';";
    }).join("\r\n");
    re += "\r\n";
    re += "export {\r\n" + ghoti.components.map(function(it){
      return ghotiComponentExport(it) + ",";
    }).join("\r\n") + "\r\n};\r\n";
    return re;
  };
  comVueAddon = function(ghoti){
    var re;
    if (!Boolean(ghoti.components)) {
      log('ERROR, ghoti have no components configuration');
      log('Try to fix it: "ghoti fix"');
      process.exit();
    }
    re = comments('components');
    re += 'import Vue, { VueConstructor } from \'vue\';\r\n\r\n';
    re += ghoti.components.map(function(it){
      return "import " + ghotiComponentClassName(it) + " from './" + ghotiComponentFileName(it, true) + "';";
    }).join("\r\n");
    re += "\r\n\r\n";
    re += "export default {\r\n";
    re += "    install: (Vue: VueConstructor, options?: any) => {\r\n";
    re += ghoti.components.map(function(it){
      return ghotiComponentExportVue(it);
    }).join("\r\n");
    re += "\r\n    },\r\n};\r\n";
    return re;
  };
  component = function(root, targetPath, name, ghoti, whenDone, env){
    var i$, ref$, len$, i, data, target, importTarget;
    verifyNameValidation(name, 'component', whenDone);
    if (!Boolean(ghoti.components)) {
      logPad('| ERROR, ghoti have no components configuration', 1);
      logPad('| Try to fix it: "ghoti fix"', 1);
      whenDone();
      process.exit();
    }
    for (i$ = 0, len$ = (ref$ = ghoti.components).length; i$ < len$; ++i$) {
      i = ref$[i$];
      if (deepEq$(i, name, '===')) {
        log('| ERROR: component "' + name + '" is already exist');
        log('| try "ghoti status" to see component list');
        whenDone();
        process.exit();
      }
    }
    switch (ghoti.template) {
    case 'react':
      data = readFile(pathBuilder(root, libComponent('react-tsx')), name, ghoti);
      target = path.join(targetPath, "src", "component", name + ".component.tsx");
      importTarget = path.join(targetPath, "src", "component", "import.ts");
      break;
    case 'react-js':
      data = readFile(pathBuilder(root, libComponent('react-jsx')), name, ghoti);
      target = path.join(targetPath, "src", "component", name + ".component.jsx");
      importTarget = path.join(targetPath, "src", "component", "import.js");
      break;
    case 'vue':
      data = readFile(pathBuilder(root, libComponent('vue')), name, ghoti);
      target = path.join(targetPath, "src", "component", name + ".component.vue");
      importTarget = path.join(targetPath, "src", "component", "addon.ts");
      break;
    default:
      log('| ERROR: type "' + ghoti.template + '" is not supported');
      log('| Try "ghoti status" to see current type issue');
      log('| Try "ghoti whatis ' + ghoti.template + '" is there any known issue');
      whenDone();
      process.exit();
    }
    ghoti.components.push(name);
    log('| update .ghoticonfig file');
    updateConfig(ghoti);
    switch (ghoti.template) {
    case 'vue':
      log('| update addon setting');
      fs.writeFileSync(importTarget, comVueAddon(ghoti), 'utf8');
      break;
    default:
      log('| update import setting');
      fs.writeFileSync(importTarget, comImport(ghoti), 'utf8');
    }
    log('| initialize component script');
    return fs.writeFileSync(target, data, 'utf8');
  };
  out$.component = component;
  out$.ghotiComponentFileName = ghotiComponentFileName;
  function deepEq$(x, y, type){
    var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
        has = function (obj, key) { return hasOwnProperty.call(obj, key); };
    var first = true;
    return eq(x, y, []);
    function eq(a, b, stack) {
      var className, length, size, result, alength, blength, r, key, ref, sizeB;
      if (a == null || b == null) { return a === b; }
      if (a.__placeholder__ || b.__placeholder__) { return true; }
      if (a === b) { return a !== 0 || 1 / a == 1 / b; }
      className = toString.call(a);
      if (toString.call(b) != className) { return false; }
      switch (className) {
        case '[object String]': return a == String(b);
        case '[object Number]':
          return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
        case '[object Date]':
        case '[object Boolean]':
          return +a == +b;
        case '[object RegExp]':
          return a.source == b.source &&
                 a.global == b.global &&
                 a.multiline == b.multiline &&
                 a.ignoreCase == b.ignoreCase;
      }
      if (typeof a != 'object' || typeof b != 'object') { return false; }
      length = stack.length;
      while (length--) { if (stack[length] == a) { return true; } }
      stack.push(a);
      size = 0;
      result = true;
      if (className == '[object Array]') {
        alength = a.length;
        blength = b.length;
        if (first) {
          switch (type) {
          case '===': result = alength === blength; break;
          case '<==': result = alength <= blength; break;
          case '<<=': result = alength < blength; break;
          }
          size = alength;
          first = false;
        } else {
          result = alength === blength;
          size = alength;
        }
        if (result) {
          while (size--) {
            if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
          }
        }
      } else {
        if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
          return false;
        }
        for (key in a) {
          if (has(a, key)) {
            size++;
            if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
          }
        }
        if (result) {
          sizeB = 0;
          for (key in b) {
            if (has(b, key)) { ++sizeB; }
          }
          if (first) {
            if (type === '<<=') {
              result = size < sizeB;
            } else if (type === '<==') {
              result = size <= sizeB
            } else {
              result = size === sizeB;
            }
          } else {
            first = false;
            result = size === sizeB;
          }
        }
      }
      stack.pop();
      return result;
    }
  }
}).call(this);
